package com.persagy.proxy.adm.service;

import com.alibaba.fastjson.JSONArray;
import com.persagy.proxy.adm.request.AdmQueryCriteria;
import com.persagy.proxy.common.entity.DmpResult;
import com.persagy.proxy.common.entity.InstanceUrlParam;

import java.util.List;

/**
 * ADM 通用接口
 * @author Charlie Yu
 * @date 2021-08-16
 */
public interface IAdmBaseService<T> {

    /**
     * 查询
     * @param request
     * @return
     */
    DmpResult<JSONArray> doQuery(InstanceUrlParam context, AdmQueryCriteria request);

    /**
     * 新增
     * @param context
     * @param clazz
     * @param voList
     * @return
     */
    List<T> doInsert(InstanceUrlParam context, Class<T> clazz, List<T> voList);

    /**
     * 修改
     * @param context
     * @param clazz
     * @param voList
     * @return
     */
    List<T> doUpdate(InstanceUrlParam context, Class<T> clazz, List<T> voList);

    /**
     * 删除
     * @param context
     * @param voList
     * @return
     */
    void doDelete(InstanceUrlParam context, List<T> voList);
}
